## quick-lint-js-2.3.0.tar.gz

=== CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
if (POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif ()

file(READ version QUICK_LINT_JS_VERSION)
string(REGEX MATCH "^[^\n]+" QUICK_LINT_JS_VERSION "${QUICK_LINT_JS_VERSION}")

project(quick-lint-js)

include(GNUInstallDirs)

option(QUICK_LINT_JS_ENABLE_BENCHMARKS "Build microbenchmark programs" OFF)
option(QUICK_LINT_JS_ENABLE_VSCODE "Build VS Code extension bits" OFF)

if (${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.17.3)
  option(QUICK_LINT_JS_PRECOMPILE_HEADERS "Use CMake's target_precompile_headers" ON)
else ()
  set(QUICK_LINT_JS_PRECOMPILE_HEADERS FALSE)
endif ()

set(
  QUICK_LINT_JS_INSTALL_EMACS_DIR
  "${CMAKE_INSTALL_DATAROOTDIR}/emacs/site-elisp"
  CACHE
  STRING
  "Install Emacs Lisp files into this directory relative to CMAKE_INSTALL_PREFIX"
)
set(
  QUICK_LINT_JS_INSTALL_LICENSES_DIR
  "${CMAKE_INSTALL_DOCDIR}"
  CACHE
  STRING
  "Install licenses into this directory relative to CMAKE_INSTALL_PREFIX"
)
set(
  QUICK_LINT_JS_INSTALL_NEOVIM_DIR
  "${CMAKE_INSTALL_DATAROOTDIR}/nvim/site"
  CACHE
  STRING
  "Install Neovim files into this directory relative to CMAKE_INSTALL_PREFIX"
)
set(
  QUICK_LINT_JS_INSTALL_VIM_DIR
  "${CMAKE_INSTALL_DATAROOTDIR}/vim/vimfiles"
  CACHE
  STRING
  "Install Vim files into this directory relative to CMAKE_INSTALL_PREFIX"
)
option(
  QUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS
  "Install a 'tags' file with Vim and Neovim documentation"
  OFF
)

option(
  QUICK_LINT_JS_USE_BUNDLED_BOOST
  "Use the third-party Boost library bundled with quick-lint-js instead of using the host-installed Boost"
  ON
)
option(
  QUICK_LINT_JS_USE_BUNDLED_GOOGLE_BENCHMARK
  "Use the third-party Google Benchmark library bundled with quick-lint-js instead of using the host-installed Google Benchmark"
  ON
)
option(
  QUICK_LINT_JS_USE_BUNDLED_GOOGLE_TEST
  "Use the third-party Google Test library bundled with quick-lint-js instead of using the host-installed Google Test"
  ON
)
option(
  QUICK_LINT_JS_USE_BUNDLED_SIMDJSON
  "Use the third-party simdjson library bundled with quick-lint-js instead of using the host-installed simdjson"
  ON
)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(QuickLintJSCompiler)

quick_lint_js_set_cxx_standard()
quick_lint_js_enable_char8_t_if_supported()
quick_lint_js_configure_exception_handling()
quick_lint_js_configure_rtti()
quick_lint_js_work_around_implicit_link_directories()
quick_lint_js_enable_dead_code_stripping()

# HACK(strager): Work around issues with CI. We should consider using
# find_package(Python3) instead.
find_package(PythonInterp 3.7)

find_package(PythonInterp 3)  # Force Python 3 (instead of Python 2).

if (QUICK_LINT_JS_ENABLE_BENCHMARKS)
  include(vendor/benchmark.cmake)
endif ()
include(vendor/boost.cmake)
include(vendor/googletest.cmake)
include(vendor/node-addon-api.cmake)
include(vendor/node.cmake)
include(vendor/simdjson.cmake)

if (QUICK_LINT_JS_ENABLE_BENCHMARKS)
  add_subdirectory(benchmark)
endif ()
add_subdirectory(docs)
add_subdirectory(fuzz)
add_subdirectory(plugin/vim)
add_subdirectory(plugin/emacs)
add_subdirectory(plugin/vscode)
add_subdirectory(src)
add_subdirectory(website/wasm)
add_subdirectory(completions)
include(CTest)
if (BUILD_TESTING)
  add_subdirectory(test)
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== benchmark/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(QuickLintJSTarget)

add_subdirectory(benchmark-lsp)

function (quick_lint_js_add_benchmark_executable TARGET_NAME)
  set(SOURCES "${ARGN}")
  quick_lint_js_add_executable("${TARGET_NAME}" ${SOURCES})
  target_link_libraries(
    "${TARGET_NAME}"
    PRIVATE
    benchmark::benchmark
    benchmark::benchmark_main
    quick-lint-js-benchmark-support
    quick-lint-js-lib
  )
endfunction ()

quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-cli-location
  benchmark-cli-location.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-configuration
  benchmark-configuration.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-configuration-loader
  benchmark-configuration-loader.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-document
  benchmark-document.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lex
  benchmark-lex.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lint
  benchmark-lint.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lsp
  benchmark-lsp.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-lsp-location
  benchmark-lsp-location.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-parse
  benchmark-parse.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-translation
  benchmark-translation.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-utf-8
  benchmark-utf-8.cpp
)
quick_lint_js_add_benchmark_executable(
  quick-lint-js-benchmark-vim-location
  benchmark-vim-location.cpp
)

quick_lint_js_add_library(
  quick-lint-js-benchmark-support
  generate-code.cpp
  quick-lint-js/generate-code.h
)
target_include_directories(quick-lint-js-benchmark-support PUBLIC .)
target_link_libraries(quick-lint-js-benchmark-support PUBLIC quick-lint-js-lib)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== completions/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(GNUInstallDirs)

# zsh on Arch Linux and on Homebrew on macOS search in this path:
install(
  FILES _quick-lint-js
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/zsh/site-functions"
)
# zsh on Linux Mint searches in this path:
install(
  FILES _quick-lint-js
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/zsh/vendor-completions"
)

install(
  FILES quick-lint-js.bash
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions"
)

install(
  FILES quick-lint-js.fish
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/fish/vendor_completions.d"
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== docs/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(GNUInstallDirs)

install(
  FILES man/quick-lint-js.1
  DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
)
install(
  FILES man/quick-lint-js.config.5
  DESTINATION "${CMAKE_INSTALL_MANDIR}/man5"
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== fuzz/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(QuickLintJSTarget)

option(QUICK_LINT_JS_ENABLE_LLVM_LIBFUZZER_TESTS "" OFF)

if (QUICK_LINT_JS_ENABLE_LLVM_LIBFUZZER_TESTS)
  function (quick_lint_js_add_fuzz_executable TARGET)
    quick_lint_js_add_executable("${TARGET}" ${ARGN})
    target_compile_options("${TARGET}" PRIVATE -fsanitize=fuzzer)
    target_link_libraries("${TARGET}" PRIVATE -fsanitize=fuzzer)
  endfunction ()

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-configuration-json fuzz-configuration-json.cpp)
  target_link_libraries(quick-lint-js-fuzz-configuration-json PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-lex fuzz-lex.cpp)
  target_link_libraries(quick-lint-js-fuzz-lex PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-lsp-server fuzz-lsp-server.cpp)
  target_link_libraries(quick-lint-js-fuzz-lsp-server PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-lsp-message-parser fuzz-lsp-message-parser.cpp)
  target_link_libraries(quick-lint-js-fuzz-lsp-message-parser PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-options fuzz-options.cpp)
  target_link_libraries(quick-lint-js-fuzz-options PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-parse fuzz-parse.cpp)
  target_link_libraries(quick-lint-js-fuzz-parse PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-utf-8-decode-encode fuzz-utf-8-decode-encode.cpp)
  target_link_libraries(quick-lint-js-fuzz-utf-8-decode-encode PRIVATE quick-lint-js-lib)

  quick_lint_js_add_fuzz_executable(quick-lint-js-fuzz-utf-8-lsp fuzz-utf-8-lsp.cpp)
  target_link_libraries(quick-lint-js-fuzz-utf-8-lsp PRIVATE quick-lint-js-lib)
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== src/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(GNUInstallDirs)
include(QuickLintJSCompiler)
include(QuickLintJSCopyright)
include(QuickLintJSTarget)

option(
  QUICK_LINT_JS_FEATURE_VECTOR_PROFILING
  "Enable the QLJS_DUMP_VECTORS option at run-time"
  FALSE
)

set(NEED_THREADS TRUE)

if (NEED_THREADS)
  find_package(Threads REQUIRED)
endif ()

set(EXTRA_SOURCES)
if (WIN32)
  list(APPEND EXTRA_SOURCES quick-lint-js.rc)
  # TODO(strager): Add a dependency on dusty-icon.ico which is referenced by
  # quick-lint-js.rc.
endif ()
quick_lint_js_add_executable(
  quick-lint-js
  main.cpp
  ${EXTRA_SOURCES}
)
set_target_properties(quick-lint-js PROPERTIES RUNTIME_OUTPUT_DIRECTORY ..)
target_link_libraries(quick-lint-js PRIVATE quick-lint-js-lib)

# TODO(strager): Use the default DESTINATION for CMake versions which have a
# default. (3.18.0 has a default; 3.12.4 doesn't have a default.)
install(TARGETS quick-lint-js RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

quick_lint_js_add_library(
  quick-lint-js-lib
  arg-parser.cpp
  assert.cpp
  basic-configuration-filesystem.cpp
  boost.cpp
  buffering-error-reporter.cpp
  byte-buffer.cpp
  c-api-error-reporter.cpp
  c-api.cpp
  change-detecting-filesystem-inotify.cpp
  change-detecting-filesystem-kqueue.cpp
  change-detecting-filesystem-win32.cpp
  change-detecting-filesystem.cpp
  char8.cpp
  cli-location.cpp
  configuration-loader.cpp
  configuration.cpp
  diagnostic-formatter.cpp
  diagnostic.cpp
  document.cpp
  emacs-lisp-error-reporter.cpp
  emacs-location.cpp
  error-collector.cpp
  error-list.cpp
  error.cpp
  file-canonical.cpp
  file-handle.cpp
  file-path.cpp
  file.cpp
  global-variables-browser.cpp
  global-variables.cpp
  integer.cpp
  json.cpp
  jsx.cpp
  language.cpp
  lex-keyword.cpp
  lex-unicode.cpp
  lex.cpp
  lint.cpp
  locale.cpp
  location.cpp
  logger.cpp
  lsp-error-reporter.cpp
  lsp-location.cpp
  lsp-message-parser.cpp
  lsp-pipe-writer.cpp
  lsp-server.cpp
  options.cpp
  output-stream.cpp
  padded-string.cpp
  parse.cpp
  pipe-writer.cpp
  pipe.cpp
  quick-lint-js/allocator.h
  quick-lint-js/arg-parser.h
  quick-lint-js/assert.h
  quick-lint-js/basic-configuration-filesystem.h
  quick-lint-js/bit.h
  quick-lint-js/buffering-error-reporter.h
  quick-lint-js/buffering-visitor.h
  quick-lint-js/byte-buffer.h
  quick-lint-js/c-api-error-reporter.h
  quick-lint-js/c-api.h
  quick-lint-js/change-detecting-filesystem.h
  quick-lint-js/char8.h
  quick-lint-js/cli-location.h
  quick-lint-js/configuration-loader.h
  quick-lint-js/configuration.h
  quick-lint-js/consteval.h
  quick-lint-js/cpp.h
  quick-lint-js/crash.h
  quick-lint-js/diagnostic-formatter.h
  quick-lint-js/diagnostic.h
  quick-lint-js/document.h
  quick-lint-js/emacs-lisp-error-reporter.h
  quick-lint-js/emacs-location.h
  quick-lint-js/error-collector.h
  quick-lint-js/error-list.h
  quick-lint-js/error-reporter.h
  quick-lint-js/error-tape.h
  quick-lint-js/error.h
  quick-lint-js/event-loop.h
  quick-lint-js/expression.h
  quick-lint-js/feature.h
  quick-lint-js/file-canonical.h
  quick-lint-js/file-handle.h
  quick-lint-js/file-path.h
  quick-lint-js/file.h
  quick-lint-js/force-inline.h
  quick-lint-js/global-variables.h
  quick-lint-js/hash-fnv.h
  quick-lint-js/have.h
  quick-lint-js/integer.h
  quick-lint-js/json.h
  quick-lint-js/jsx.h
  quick-lint-js/language.h
  quick-lint-js/lex.h
  quick-lint-js/linked-bump-allocator.h
  quick-lint-js/lint.h
  quick-lint-js/locale.h
  quick-lint-js/location.h
  quick-lint-js/log.h
  quick-lint-js/logger.h
  quick-lint-js/lsp-endpoint.h
  quick-lint-js/lsp-error-reporter.h
  quick-lint-js/lsp-location.h
  quick-lint-js/lsp-message-parser.h
  quick-lint-js/lsp-pipe-writer.h
  quick-lint-js/lsp-server.h
  quick-lint-js/math-overflow.h
  quick-lint-js/narrow-cast.h
  quick-lint-js/null-visitor.h
  quick-lint-js/optional.h
  quick-lint-js/options.h
  quick-lint-js/output-stream.h
  quick-lint-js/padded-string.h
  quick-lint-js/parse-expression-inl.h
  quick-lint-js/parse-statement-inl.h
  quick-lint-js/parse-visitor.h
  quick-lint-js/parse.h
  quick-lint-js/pipe-writer.h
  quick-lint-js/pipe.h
  quick-lint-js/result.h
  quick-lint-js/simd.h
  quick-lint-js/simdjson.h
  quick-lint-js/temporary-directory.h
  quick-lint-js/text-error-reporter.h
  quick-lint-js/translation-table-generated.h
  quick-lint-js/translation-table.h
  quick-lint-js/translation.h
  quick-lint-js/unreachable.h
  quick-lint-js/uri.h
  quick-lint-js/utf-16.h
  quick-lint-js/utf-8.h
  quick-lint-js/vector.h
  quick-lint-js/version.h
  quick-lint-js/vim-location.h
  quick-lint-js/vim-qflist-json-error-reporter.h
  quick-lint-js/windows.h
  quick-lint-js/warning.h
  quick-lint-js/web-demo-location.h
  simdjson.cpp
  temporary-directory.cpp
  text-error-reporter.cpp
  translation-table-generated.cpp
  translation.cpp
  uri.cpp
  utf-16.cpp
  utf-8.cpp
  vector-profiler.cpp
  vim-location.cpp
  vim-qflist-json-error-reporter.cpp
  web-demo-location.cpp
)
target_compile_definitions(
  quick-lint-js-lib
  PUBLIC
  "QUICK_LINT_JS_VERSION=${QUICK_LINT_JS_VERSION}"
)
target_include_directories(quick-lint-js-lib PUBLIC .)
target_link_libraries(quick-lint-js-lib PUBLIC boost simdjson)
if (WIN32)
  target_link_libraries(quick-lint-js-lib PUBLIC Pathcch)
endif ()
if (NEED_THREADS)
  target_link_libraries(quick-lint-js-lib PRIVATE Threads::Threads)
endif ()
if (QUICK_LINT_JS_PRECOMPILE_HEADERS)
  target_precompile_headers(
    quick-lint-js-lib
    PUBLIC
    <boost/container/pmr/polymorphic_allocator.hpp>
    <cmath>
    <cstring>
    <simdjson.h>
    <string>
  )
endif ()

if (QUICK_LINT_JS_FEATURE_VECTOR_PROFILING)
  target_compile_definitions(
    quick-lint-js-lib
    PUBLIC
    QLJS_FEATURE_VECTOR_PROFILING=1
  )
else ()
  target_compile_definitions(
    quick-lint-js-lib
    PUBLIC
    QLJS_FEATURE_VECTOR_PROFILING=0
  )
endif ()

quick_lint_js_have_charconv(QUICK_LINT_JS_HAVE_CHARCONV)
if (NOT QUICK_LINT_JS_HAVE_CHARCONV)
  target_compile_definitions(
    quick-lint-js-lib
    PUBLIC
    QLJS_HAVE_CHARCONV_HEADER=0
  )
endif ()

# HACK(strager): Work around GCC compiler bug. GCC 9.3.0 miscompiles a call to
# strncmp, causing the length given to strncmp to be incorrect. (Perhaps we are
# invoking undefined behaviour though with our string table offset pointer
# arithmetic? Unsure.) The bug appears to be fixed in GCC 10.1.0.
#
# Possibly related: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=92765
#
# To work around the bug, apply -fno-builtin to the target. If we apply it only
# to the source file, the flag seems to be ignored when using precompiled
# headers.
if (
  CMAKE_CXX_COMPILER_ID STREQUAL GNU
  AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10.1.0
)
  target_compile_options(quick-lint-js-lib PRIVATE -fno-builtin)
endif ()

quick_lint_js_collect_copyright(
  quick-lint-js-licenses
  TARGET quick-lint-js
  OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/quick-lint-js-licenses.txt"
)
if (TARGET quick-lint-js-licenses)
  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/quick-lint-js-licenses.txt"
    DESTINATION "${QUICK_LINT_JS_INSTALL_LICENSES_DIR}"
    RENAME copyright
  )
endif ()

quick_lint_js_add_library(
  quick-lint-js-boost-json
  boost-json.cpp
  quick-lint-js/boost-json.h
)
target_include_directories(quick-lint-js-boost-json PUBLIC .)
target_link_libraries(
  quick-lint-js-boost-json
  PUBLIC
  boost_json
  quick-lint-js-lib
)
target_compile_definitions(
  quick-lint-js-boost-json
  PRIVATE
  QLJS_BUILDING_QLJS_BOOST_JSON
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== test/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(QuickLintJSCompiler)
include(QuickLintJSTarget)

quick_lint_js_add_executable(
  quick-lint-js-test
  error-matcher.cpp
  parse-json.cpp
  parse-support.cpp
  quick-lint-js/array.h
  quick-lint-js/characters.h
  quick-lint-js/error-matcher.h
  quick-lint-js/file-matcher.h
  quick-lint-js/gtest.h
  quick-lint-js/mock-inotify.h
  quick-lint-js/mock-kqueue.h
  quick-lint-js/mock-win32.h
  quick-lint-js/parse-json.h
  quick-lint-js/parse-support.h
  quick-lint-js/spy-lsp-endpoint-remote.h
  quick-lint-js/spy-lsp-message-parser.h
  quick-lint-js/spy-visitor.h
  spy-visitor.cpp
  test-array.cpp
  test-assert.cpp
  test-bit.cpp
  test-buffering-error-reporter.cpp
  test-buffering-visitor.cpp
  test-byte-buffer.cpp
  test-c-api.cpp
  test-cli-location.cpp
  test-configuration-loader.cpp
  test-configuration.cpp
  test-crash.cpp
  test-diagnostic-formatter.cpp
  test-diagnostic.cpp
  test-document.cpp
  test-emacs-lisp-error-reporter.cpp
  test-emacs-location.cpp
  test-error-list.cpp
  test-error-matcher.cpp
  test-error.cpp
  test-event-loop.cpp
  test-file-canonical.cpp
  test-file-path.cpp
  test-file.cpp
  test-hash-fnv.cpp
  test-integer-decimal.cpp
  test-integer-hexadecimal.cpp
  test-json.cpp
  test-lex.cpp
  test-linked-bump-allocator.cpp
  test-lint-parse.cpp
  test-lint.cpp
  test-locale.cpp
  test-lsp-endpoint.cpp
  test-lsp-error-reporter.cpp
  test-lsp-location.cpp
  test-lsp-message-parser.cpp
  test-lsp-pipe-writer.cpp
  test-lsp-server.cpp
  test-math-overflow.cpp
  test-narrow-cast.cpp
  test-options.cpp
  test-output-stream.cpp
  test-padded-string.cpp
  test-parse-class.cpp
  test-parse-expression-jsx.cpp
  test-parse-expression-statement.cpp
  test-parse-expression.cpp
  test-parse-function.cpp
  test-parse-jsx.cpp
  test-parse-loop.cpp
  test-parse-module.cpp
  test-parse-statement.cpp
  test-parse-var.cpp
  test-parse-warning.cpp
  test-parse.cpp
  test-pipe-writer.cpp
  test-result.cpp
  test-simd.cpp
  test-string-view.cpp
  test-temporary-directory.cpp
  test-text-error-reporter.cpp
  test-translation.cpp
  test-uri.cpp
  test-utf-16.cpp
  test-utf-8.cpp
  test-vector-profiler.cpp
  test-vector.cpp
  test-vim-location.cpp
  test-vim-qflist-json-error-reporter.cpp
  test-web-demo-location.cpp
  test-write-integer.cpp
)
target_include_directories(quick-lint-js-test PRIVATE .)
target_link_libraries(
  quick-lint-js-test
  PRIVATE
  boost
  boost_json
  gmock
  gmock_main
  gtest
  quick-lint-js-boost-json
  quick-lint-js-lib
)
if (QUICK_LINT_JS_PRECOMPILE_HEADERS)
  target_precompile_headers(
    quick-lint-js-test
    PRIVATE
    <boost/container/pmr/polymorphic_allocator.hpp>
    <gmock/gmock.h>
    <gtest/gtest.h>
    <iostream>
    <simdjson.h>
  )
endif ()
quick_lint_js_enable_bigobj_if_supported(quick-lint-js-test)

add_test(
  NAME quick-lint-js-test
  COMMAND quick-lint-js-test
)

# Disable MSVC warnings in googletest's headers.
# TODO(strager): Use MSVC's /external switches instead.
quick_lint_js_add_warning_options_if_supported(
  quick-lint-js-test
  PRIVATE
  /wd26495 # Always initialize a member variable
  /wd26812 # Prefer 'enum class' over 'enum'
)

# HACK(strager): UndefinedBehaviorSanitizer is buggy on Linux x86_64 with GCC
# 8.4.0. Disable some UBSAN checks to avoid false positives.
if (
  CMAKE_CXX_COMPILER_ID STREQUAL GNU
  AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0
)
  set_source_files_properties(
    test-lex.cpp
    PROPERTIES
    COMPILE_OPTIONS -fno-sanitize=null
  )
endif ()

find_package(ICU COMPONENTS uc)
if (ICU_FOUND)
  quick_lint_js_add_executable(
    quick-lint-js-test-lex-unicode
    test-lex-unicode.cpp
  )
  target_link_libraries(
    quick-lint-js-test-lex-unicode
    PRIVATE
    ICU::uc
    gmock
    gmock_main
    gtest
    quick-lint-js-lib
  )
  if (QUICK_LINT_JS_PRECOMPILE_HEADERS)
    target_precompile_headers(
      quick-lint-js-test-lex-unicode
      PRIVATE
      <gmock/gmock.h>
      <gtest/gtest.h>
    )
  endif ()

  add_test(
    NAME quick-lint-js-test-lex-unicode
    COMMAND quick-lint-js-test-lex-unicode
  )
endif ()

find_package(PythonInterp 3.7)
if (PYTHONINTERP_FOUND)
  add_test(
    NAME quick-lint-js-test-cli
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/test-cli.py
  )
  set_property(
    TEST quick-lint-js-test-cli
    APPEND PROPERTY ENVIRONMENT QUICK_LINT_JS_EXE=$<TARGET_FILE:quick-lint-js>
  )
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== benchmark/benchmark-lsp/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(CheckCXXSourceCompiles)
include(CheckIncludeFileCXX)
include(QuickLintJSTarget)

check_include_file_cxx(
  experimental/coroutine
  QUICK_LINT_JS_HAVE_EXPERIMENTAL_COROUTINE
)
check_cxx_source_compiles(
  "#include <filesystem>
int main() {
  return std::filesystem::path(u8\"hello\").empty() ? 2 : 0;
}"
  QUICK_LINT_JS_HAVE_FILESYSTEM_CHAR8
)
if (QUICK_LINT_JS_HAVE_EXPERIMENTAL_COROUTINE AND QUICK_LINT_JS_HAVE_FILESYSTEM_CHAR8)
  quick_lint_js_add_executable(
    quick-lint-js-benchmark-lsp-servers
    benchmark-config.cpp
    lsp-benchmarks.cpp
    lsp-server-process.cpp
    main.cpp
    process.cpp
    quick-lint-js/benchmark-config.h
    quick-lint-js/lsp-benchmarks.h
    quick-lint-js/lsp-logging.h
    quick-lint-js/lsp-server-process.h
    quick-lint-js/process.h
  )
  target_link_libraries(
    quick-lint-js-benchmark-lsp-servers
    PRIVATE
    boost_json
    quick-lint-js-boost-json
    quick-lint-js-lib
    simdjson
  )
  target_include_directories(quick-lint-js-benchmark-lsp-servers PRIVATE .)
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== plugin/emacs/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(GNUInstallDirs)

install(
  FILES flycheck-quicklintjs.el
  FILES lsp-quicklintjs.el
  FILES eglot-quicklintjs.el
  FILES flymake-quicklintjs.el
  DESTINATION "${QUICK_LINT_JS_INSTALL_EMACS_DIR}"
)

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== plugin/vim/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(GNUInstallDirs)

set(
  VIM_FILES
  ale_linters/javascript/quick_lint_js.vim
  autoload/quick_lint_js_ale.vim
  doc/quick-lint-js.txt
  plugin/quick-lint-js.vim
)
if (QUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS)
  list(APPEND VIM_FILES doc/tags)
endif ()
foreach (FILE IN LISTS VIM_FILES)
  get_filename_component(DIR "${FILE}" DIRECTORY)
  install(
    FILES "quick-lint-js.vim/${FILE}"
    DESTINATION "${QUICK_LINT_JS_INSTALL_VIM_DIR}/${DIR}"
  )
endforeach ()

set(
  NEOVIM_FILES
  ${VIM_FILES}
  lua/lspconfig/quick_lint_js.lua
)
foreach (FILE IN LISTS NEOVIM_FILES)
  get_filename_component(DIR "${FILE}" DIRECTORY)
  install(
    FILES "quick-lint-js.vim/${FILE}"
    DESTINATION "${QUICK_LINT_JS_INSTALL_NEOVIM_DIR}/${DIR}"
  )
endforeach ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== plugin/vscode/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(QuickLintJSCopyright)
include(QuickLintJSNodeJS)
include(QuickLintJSTarget)

set(VSCODE_DIST_DIR dist)

if (QUICK_LINT_JS_ENABLE_VSCODE AND NOT EMSCRIPTEN)
  if (QUICK_LINT_JS_NODEJS_OS_PLATFORM AND QUICK_LINT_JS_NODEJS_OS_ARCH)
    quick_lint_js_add_library(
      quick-lint-js-vscode-node
      SHARED
      quick-lint-js-vscode-node.cpp
      quick-lint-js/napi-support.h
      quick-lint-js/vscode-error-reporter.h
      quick-lint-js/vscode.h
    )
    set_target_properties(
      quick-lint-js-vscode-node
      PROPERTIES
      PREFIX ""
      SUFFIX "_${QUICK_LINT_JS_NODEJS_OS_PLATFORM}-${QUICK_LINT_JS_NODEJS_OS_ARCH}.node"
    )
    target_compile_definitions(quick-lint-js-vscode-node PRIVATE NAPI_VERSION=6)
    target_include_directories(quick-lint-js-vscode-node PRIVATE .)
    target_link_libraries(
      quick-lint-js-vscode-node
      PRIVATE
      node-addon-api
      quick-lint-js-lib
    )
    install(
      TARGETS quick-lint-js-vscode-node
      LIBRARY  # Linux DSO; macOS dylib
        COMPONENT vscode-node
        EXCLUDE_FROM_ALL
        DESTINATION "${VSCODE_DIST_DIR}"
      RUNTIME  # Windows DLL
        COMPONENT vscode-node
        EXCLUDE_FROM_ALL
        DESTINATION "${VSCODE_DIST_DIR}"
    )

    if (CMAKE_SYSTEM_NAME STREQUAL Linux)
      target_link_libraries(
        quick-lint-js-vscode-node
        PRIVATE
        -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js-vscode-node.map
      )
    endif ()
    if (CMAKE_SYSTEM_NAME STREQUAL Darwin)
      target_link_libraries(
        quick-lint-js-vscode-node
        PRIVATE
        -Wl,-dead_strip
        -Wl,-exported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/quick-lint-js-vscode-node.exports
      )
    endif ()

    quick_lint_js_collect_copyright(
      quick-lint-js-vscode-node-licenses
      TARGET quick-lint-js-vscode-node
      OUTPUT_FILE quick-lint-js-vscode-node-licenses.txt
      EXTRA_VENDOR_PROJECTS node node-addon-api
    )
    if (TARGET quick-lint-js-vscode-node-licenses)
      install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/quick-lint-js-vscode-node-licenses.txt"
        COMPONENT vscode-node
        DESTINATION "${VSCODE_DIST_DIR}"
        EXCLUDE_FROM_ALL
        RENAME "copyright_quick-lint-js-vscode-node_${QUICK_LINT_JS_NODEJS_OS_PLATFORM}-${QUICK_LINT_JS_NODEJS_OS_ARCH}.txt"
      )
    endif ()
  else ()
    if (NOT QUICK_LINT_JS_NODEJS_OS_PLATFORM)
      message(WARNING "Could not determine Node.js os.platform (QUICK_LINT_JS_NODEJS_OS_PLATFORM) (CMAKE_SYSTEM_NAME is ${CMAKE_SYSTEM_NAME}); not building Node.js extension")
    else ()
      message(WARNING "Could not determine Node.js os.arch (QUICK_LINT_JS_NODEJS_OS_ARCH) (CMAKE_SYSTEM_PROCESSOR is ${CMAKE_SYSTEM_PROCESSOR}); not building Node.js extension")
    endif ()
  endif ()
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== website/wasm/CMakeLists.txt ===
# Copyright (C) 2020  Matthew "strager" Glazar
# See end of file for extended copyright information.

cmake_minimum_required(VERSION 3.10)
include(QuickLintJSCopyright)
include(QuickLintJSNodeJS)
include(QuickLintJSTarget)

set(VSCODE_DIST_DIR dist)

if (EMSCRIPTEN)
  # TODO(strager): Rename.
  quick_lint_js_add_executable(quick-lint-js-vscode empty.cpp)
  target_link_libraries(
    quick-lint-js-vscode
    PRIVATE
    quick-lint-js-lib
    "-sEXPORTED_FUNCTIONS=[\"_qljs_web_demo_create_document\",\"_qljs_web_demo_destroy_document\",\"_qljs_web_demo_set_text\",\"_qljs_web_demo_set_config_text\",\"_qljs_web_demo_lint\",\"_qljs_web_demo_lint_as_config_file\",\"_malloc\",\"_free\"]"
    -sASSERTIONS=0
    -sSTANDALONE_WASM=1
    -sSUPPORT_LONGJMP=1
    --no-entry
  )
  set_target_properties(quick-lint-js-vscode PROPERTIES SUFFIX .wasm)

  install(
    TARGETS quick-lint-js-vscode
    RUNTIME
    COMPONENT vscode
    EXCLUDE_FROM_ALL
    DESTINATION "${VSCODE_DIST_DIR}"
  )

  quick_lint_js_collect_copyright(
    quick-lint-js-vscode-licenses
    TARGET quick-lint-js-vscode
    OUTPUT_FILE quick-lint-js-vscode-licenses.txt
  )
  if (TARGET quick-lint-js-vscode-licenses)
    install(
      FILES "${CMAKE_CURRENT_BINARY_DIR}/quick-lint-js-vscode-licenses.txt"
      COMPONENT vscode
      DESTINATION "${VSCODE_DIST_DIR}"
      EXCLUDE_FROM_ALL
      RENAME copyright.txt
    )
  endif ()
endif ()

# quick-lint-js finds bugs in JavaScript programs.
# Copyright (C) 2020  Matthew "strager" Glazar
#
# This file is part of quick-lint-js.
#
# quick-lint-js is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# quick-lint-js is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with quick-lint-js.  If not, see <https://www.gnu.org/licenses/>.

=== dist/debian/debian/changelog ===
quick-lint-js (2.3.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 24 Feb 2022 19:38:31 -0800

quick-lint-js (2.2.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 17 Feb 2022 20:56:04 -0800

quick-lint-js (2.1.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Wed, 09 Feb 2022 14:57:29 -0800

quick-lint-js (2.0.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 08 Feb 2022 16:53:45 -0800

quick-lint-js (1.0.0-1) unstable; urgency=medium

  * New release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 13 Dec 2021 19:33:18 -0800

quick-lint-js (0.7.1-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 06 Dec 2021 21:25:21 -0800

quick-lint-js (0.7.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sun, 05 Dec 2021 15:30:51 -0800

quick-lint-js (0.6.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Sat, 20 Nov 2021 16:32:38 -0700

quick-lint-js (0.5.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Tue, 12 Oct 2021 20:57:21 -0700

quick-lint-js (0.4.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 09 Sep 2021 09:04:53 -0700

quick-lint-js (0.3.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Fri, 02 Jul 2021 19:20:46 -0700

quick-lint-js (0.2.0-1) unstable; urgency=medium

  * New beta release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Mon, 05 Apr 2021 19:28:08 -0700

quick-lint-js (0.1.0-1) unstable; urgency=medium

  * Initial release.

 -- Matthew "strager" Glazar <strager.nds@gmail.com>  Thu, 14 Jan 2021 19:25:47 -0800

=== dist/debian/debian/control ===
Source: quick-lint-js
Section: devel
Priority: optional
Maintainer: Matthew "strager" Glazar <strager.nds@gmail.com>
Build-Depends: debhelper (>= 9), cmake (>= 3.10), gcc-9, g++-9
Standards-Version: 4.5.1.0
Homepage: https://quick-lint-js.com/
Vcs-Browser: https://github.com/quick-lint/quick-lint-js
Vcs-Git: https://github.com/quick-lint/quick-lint-js.git

Package: quick-lint-js
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JavaScript linter
 quick-lint-js finds bugs in your JavaScript code.

Package: quick-lint-js-dbgsym
Section: debug
Architecture: any
Depends: ${misc:Depends}, quick-lint-js
Description: debug symbols for quick-lint-js (JavaScript linter)
 quick-lint-js finds bugs in your JavaScript code.

Package: quick-lint-js-vim
Architecture: all
Depends: ${misc:Depends}, quick-lint-js, vim, vim-addon-manager
Description: Vim and Neovim plugin for quick-lint-js
 quick-lint-js finds bugs in your JavaScript code.

=== dist/debian/debian/rules ===
#!/usr/bin/make -f

export CC = gcc-9
export CXX = g++-9

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DQUICK_LINT_JS_INSTALL_VIM_DIR=share/vim/addons -DQUICK_LINT_JS_INSTALL_VIM_NEOVIM_TAGS=ON

override_dh_auto_install:
	dh_auto_install
	install -m644 -D plugin/vim/quick-lint-js.yaml debian/tmp/usr/share/vim/registry/quick-lint-js.yaml

override_dh_strip:
	dh_strip $@ --dbg-package=quick-lint-js-dbgsym
